unit NNNodeStructure;

interface

uses
    math;

type
    TNNNode = Class(TObject)
    private
        FData:Pointer;
        FSize:Integer;
        Next:TNNNode;
        Prev:TNNNode;
    public

        property Data:Pointer read FData;
        property Size:Integer read FSize;
        constructor Create(_data:Pointer;_size:Integer);
        //ʂ̃|C^ƂĎgꍇ́A_size0ɂ
        destructor Destroy;override;
    end;

    TNNQueue = Class(TObject)
    private
        FHead:TNNNode;
        FTail:TNNNode;
        FCount:Integer;
        PickedNode:TNNNode;//Pickŉ
    public
        property Count:Integer read FCount;
        destructor Destroy;override;
        procedure Put(_data:Pointer;_size:Integer);
        function Pick:Pointer;
    end;

    {
        Format
        i : Integer


    }
    function Pack(Format:String;const Args:Array of const):String;
    procedure UnPack(Source:String;Format:String;Args:Array of Pointer);

implementation

function Pack(Format:String;const Args:Array of const):String;
var
    ac,fc,c:integer;//ArgsCount  FormatCount

    i:integer;  //forJE^
    ret:String;
    len:Integer;
    temp:Integer;
begin
    ac:=Length(Args);
    fc:=Length(Format);
    c:=Min(ac,fc);    //vfȂƂ́Aقɂ킹

    ret:='';        //Ԃlp

    For i:=0 to c-1 do begin        //vf[v
        Case Format[i+1] of         //tH[}bg̓JE^ʒuƈ
            //i:Integer
            'i':begin
                //4oCgg
                Len:=Length(ret);
                SetLength(ret,len+4);
                //4oCgRs[
                Move(Args[i],ret[len+1],4);
            end;
            //t:text string@TCYAf[^@ŋLq
            't':begin
                //(i̎Ɠ
                //i[̒𒲂ׂ
                temp:=Length(String(PString(@Args[i])^));
                //4oCgg
                Len:=Length(ret);
                SetLength(ret,len+4);
                //4oCgRs[
                Move(temp,ret[len+1],4);

                //񕔕
                //񒷂g
                Len:=Length(ret);
                SetLength(ret,len+temp);
                //񒷂Rs[
                Move(String(PString(@Args[i])^)[1],ret[len+1],temp);
            end;
        end;
    end;

    result:=ret;
end;

procedure UnPack(Source:String;Format:String;Args:Array of Pointer);
var
    ac,fc,c:integer;//ArgsCount  FormatCount

    i:integer;  //forJE^
    temp:Integer;
    spos:integer;//SourcePos
begin
    ac:=Length(Args);
    fc:=Length(Format);
    c:=Min(ac,fc);    //vfȂƂ́Aقɂ킹

    spos:=1;
    For i:=0 to c-1 do begin        //vf[v
        Case Format[i+1] of         //tH[}bg̓JE^ʒuƈ
            //i:Integer
            'i':begin
                //4oCgRs[
                Move(source[spos],Args[i]^,4);
                //4oCgi
                spos:=spos+4;
            end;
            //t:text string@TCYAf[^@ŋLq
            't':begin
                //ǂݍ(i̎Ɠ
                //4oCgRs[
                Move(Source[spos],temp,4);
                //4oCgi
                spos:=spos+4;

                //QƐ̕:=񒷂؂o
                String(PString(Args[i])^):=Copy(Source,spos,temp);
                //񒷐i
                spos:=spos+temp;
            end;
        end;
    end;


end;

constructor TNNNode.Create(_data:Pointer;_size:Integer);
begin
    inherited Create;
    if _size>0 then begin
        //m
        GetMem(FData,_size);
        //̂̂ɃRs[
        Move(_data^,FData^,_size);
        FSize:=_size;
    end else begin
        FData:=_data;
        FSize:=0;
    end;
end;

destructor TNNNode.Destroy;
begin
    if FSize>0 then begin
        //
        FreeMem(FData,FSize);
    end;
    inherited Destroy;
end;

destructor TNNQueue.Destroy;
begin
    if PickedNode<>nil then begin
        PickedNode.Free;
        PickedNode:=nil;
    end;
end;

procedure TNNQueue.Put(_data:Pointer;_size:Integer);
var node:TNNNode;
begin
    node:=TNNNode.Create(_data,_size);
    if FHead=nil then begin
        FHead:=node;
        node.Prev:=nil;
    end;
    node.Next:=nil;
    if FTail<>nil then begin
        FTail.Next:=node;
        node.Prev:=FTail;
    end;
    FTail:=node;
    FCount:=FCount+1;
end;

function TNNQueue.Pick:Pointer;
var n:TNNNode;
begin
    if FHead=nil then begin
        Result:=Nil;
        Exit;
    end;

    if PickedNode<>nil then begin
        PickedNode.Free;
        PickedNode:=nil;
    end;
    PickedNode:=FHead;

    n:=FHead.Next;
    FHead:=n;
    if n<>nil then begin
        n.Prev:=nil;
    end else begin
        FTail:=nil;
    end;

    Result:=PickedNode.Data;

    FCount:=FCount-1;

end;

end.
